%define	oname	FreeFileSync

%define __unzip	%{_bindir}/unzip -o

Name:		freefilesync
Version:	11.3
%define subrel  1
Release:	%mkrel 2
Summary:	A free file sync tool
Group:		File tools
License:	GPLv3
Url:		https://freefilesync.org/
Source0:	https://freefilesync.org/download/FreeFileSync_%{version}_Source.zip
Source2:	FreeFileSync.desktop
Source3:	RealTimeSync.desktop
Source4:	FreeFileSync.png
BuildRequires:	imagemagick
BuildRequires:	gtkmm3.0-devel
BuildRequires:	wxgtk-devel
BuildRequires:	boost-devel
BuildRequires:	curl-devel
BuildRequires:	ssh2-devel

%description
FreeFileSync is a folder comparison and synchronization tool.

%prep
%setup -q -c %{name}-%{version}
%autopatch -p1

sed -i 's_../wx+_wx+_' FreeFileSync/Source/ui/gui_generated.cpp
sed -i 's/-O3/%{optflags} -Wno-unused-local-typedefs -Wno-deprecated-declarations -Wno-literal-suffix/' FreeFileSync/Source/Makefile FreeFileSync/Source/RealTimeSync/Makefile
sed -i '/^linkFlags/s/\s\+-s\s\+/%{ldflags} /' FreeFileSync/Source/Makefile FreeFileSync/Source/RealTimeSync/Makefile

sed -i 's/m_listBoxHistory->GetTopItem()/0/g' FreeFileSync/Source/ui/main_dlg.cpp
sed -i 's!static_assert!//static_assert!' zen/scope_guard.h
sed -i 's!inline!!g' FreeFileSync/Source/ui/version_check.h

sed -i 's!gtk+-2.0!gtk+-3.0!g' FreeFileSync/Source/Makefile FreeFileSync/Source/RealTimeSync/Makefile
sed -i 's!gtk-2!gtk-3!g' FreeFileSync/Source/Makefile FreeFileSync/Source/RealTimeSync/Makefile
sed -i '/cflags gtk+-3.0/s!^\(.*\)!\1\nlinkFlags += `pkg-config --libs   gtk+-3.0`!' FreeFileSync/Source/Makefile FreeFileSync/Source/RealTimeSync/Makefile

# add '-lz' back into LINKFLAGS
sed -i '/pie/ s/-pthread/-lz -pthread/' FreeFileSync/Source/Makefile
sed -i '/pie/ s/-pthread/-lz -pthread/' FreeFileSync/Source/RealTimeSync/Makefile

# inlining of constants not present in libssh2's distributed headers
sed -i 's/MAX_SFTP_READ_SIZE/30000/g' FreeFileSync/Source/afs/sftp.cpp
sed -i 's/MAX_SFTP_OUTGOING_SIZE/30000/g' FreeFileSync/Source/afs/sftp.cpp

# fix resource dir
sed -i '/getProcessParentFolderPath/s!Resources!share/FreeFileSync!' FreeFileSync/Source/ffs_paths.cpp

%build
# FFS
%make_build -C \
	FreeFileSync/Source \
	EXENAME=FreeFileSync

# RTS
%make_build -C \
	FreeFileSync/Source/RealTimeSync \
	EXENAME=RealTimeSync

%install
for i in FreeFileSync RealTimeSync; do
  install -Dpm755 FreeFileSync/Build/Bin/$i* %{buildroot}%{_bindir}/$i
done

mkdir -p %{buildroot}%{_datadir}/%{oname}/
cp -aT FreeFileSync/Build/Resources %{buildroot}%{_datadir}/%{oname}

install -Dm644 %{_sourcedir}/%{oname}.desktop \
	%{buildroot}%{_datadir}/applications/%{oname}.desktop

install -Dm644 %{_sourcedir}/RealTimeSync.desktop \
        %{buildroot}%{_datadir}/applications/RealTimeSync.desktop

rm -rf %{buildroot}%{_docdir}/%{oname}

%files
%{_bindir}/FreeFileSync
%{_bindir}/RealTimeSync
%{_datadir}/FreeFileSync/
%{_datadir}/applications/FreeFileSync.desktop
%{_datadir}/applications/RealTimeSync.desktop


%changelog
* Wed Jan 05 2022 wally <wally> 11.3-2.1.mga8
+ Revision: 1766971
- rebuild for wxgtk 3.1.5 (mga#29848)

* Fri Jan 01 2021 wally <wally> 11.3-2.mga8
+ Revision: 1667700
- rebuild for wxgtk pre 3.1.5 snapshot

* Mon Nov 09 2020 wally <wally> 11.3-1.mga8
+ Revision: 1644147
- new version 11.3
- rebuild for new wxgtk 3.1.4
+ ovitters <ovitters>
- drop Mageia specific category from desktop file (mga#2449)
+ umeabot <umeabot>
- Mageia 8 Mass Rebuild
+ daviddavid <daviddavid>
- new version: 10.19

* Tue Nov 12 2019 wally <wally> 10.13-4.mga8
+ Revision: 1459463
- rebuild for wxgtk 3.1.3

* Mon Jul 08 2019 wally <wally> 10.13-3.mga8
+ Revision: 1419528
- rebuild for wxgtk 3.1.2 with 2.8 compatibility

* Sun Jul 07 2019 wally <wally> 10.13-2.mga8
+ Revision: 1419409
- update app menu icons

* Sun Jul 07 2019 wally <wally> 10.13-1.mga8
+ Revision: 1419404
- new version 10.13
- build with gtk3 enabled wxgtk 3.1.2

* Sun Sep 23 2018 umeabot <umeabot> 9.6-2.mga7
+ Revision: 1297769
- Mageia 7 Mass Rebuild

* Tue Jan 09 2018 wally <wally> 9.6-1.mga7
+ Revision: 1191918
- new version 9.6
- add build fixes from AUR
- add patch to fix missing includes
- rebuild for new boost

* Sat Jun 03 2017 akien <akien> 6.2-12.mga6
+ Revision: 1106094
- Rebuild for wxgtk 3.0.3.1

* Thu Jun 02 2016 daviddavid <daviddavid> 6.2-11.mga6
+ Revision: 1019876
- rebuild for wxgtk3.0 built with GTK2

* Sat Dec 26 2015 daviddavid <daviddavid> 6.2-10.mga6
+ Revision: 915175
- rebuild for new boost 1.60.0

* Fri Sep 25 2015 daviddavid <daviddavid> 6.2-9.mga6
+ Revision: 883700
- rebuild for new boost 1.59.0

* Fri Aug 14 2015 daviddavid <daviddavid> 6.2-8.mga6
+ Revision: 864766
- fix missing icon for desktop file (mga#14750)
- add BuildRequires on imagemagick
+ ycantin <ycantin>
- rebuild for new wxgtk built with wxRE_ADVANCED

* Fri Jul 31 2015 daviddavid <daviddavid> 6.2-6.mga6
+ Revision: 859997
- rebuild for new boost-1.58.0

* Thu Jul 23 2015 philippem <philippem> 6.2-5.mga6
+ Revision: 856572
- fix rebuild for new wxgtk built with gtk3
+ daviddavid <daviddavid>
- rebuild for new wxgtk built with gtk3

* Wed Oct 15 2014 umeabot <umeabot> 6.2-4.mga5
+ Revision: 744369
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 6.2-3.mga5
+ Revision: 679336
- Mageia 5 Mass Rebuild

* Fri Feb 21 2014 wally <wally> 6.2-2.mga5
+ Revision: 595247
- drop P0 and handle setting build time flags with sed magic

* Fri Feb 21 2014 wally <wally> 6.2-1.mga5
+ Revision: 595240
- add build fixes from AUR
- bundle latest zenXml with sources and build with it
- clean .spec a bit
+ fwang <fwang>
- new version  6.2

* Sat Oct 19 2013 umeabot <umeabot> 5.10-5.mga4
+ Revision: 529411
- Mageia 4 Mass Rebuild

* Tue Jul 09 2013 fwang <fwang> 5.10-4.mga4
+ Revision: 451793
- rebuild for new boost

* Thu Apr 11 2013 barjac <barjac> 5.10-3.mga3
+ Revision: 409674
- rebuild for boost-1.53

* Fri Jan 11 2013 umeabot <umeabot> 5.10-2.mga3
+ Revision: 350851
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Thu Dec 20 2012 fwang <fwang> 5.10-1.mga3
+ Revision: 333044
- new version 5.10

* Thu Dec 20 2012 fwang <fwang> 5.9-2.mga3
+ Revision: 333034
- rebuild for new boost

* Mon Nov 05 2012 juancho <juancho> 5.9-1.mga3
+ Revision: 314485
- imported package freefilesync

